2007-07-15 23:41:15 -07:00
#!/bin/sh
# Disassemble the Code: line in Linux oopses
# usage: decodecode < oops.file
#
# options: set env. variable AFLAGS=options to pass options to "as";
# e.g., to decode an i386 oops on an x86_64 system, use:
# AFLAGS=--32 decodecode < 386.oops
2008-01-14 15:18:31 -08:00
cleanup() {
2010-01-05 20:27:58 +05:30
rm -f $T $T.s $T.o $T.oo $T.aa $T.dis
2008-01-14 15:18:31 -08:00
exit 1
}
die() {
echo "$@"
exit 1
}
trap cleanup EXIT
T=`mktemp` || die "cannot create temp file"
2007-07-15 23:41:15 -07:00
code=
while read i ; do
case "$i" in
*Code:*)
code=$i
;;
esac
done
if [ -z "$code" ]; then
2008-01-14 15:18:31 -08:00
rm $T
2007-07-15 23:41:15 -07:00
exit
fi
echo $code
code=`echo $code | sed -e 's/.*Code: //'`
2010-01-05 20:27:58 +05:30
width=`expr index "$code" ' '`
2010-06-03 22:48:12 +05:30
width=$((($width-1)/2))
2010-01-05 20:27:58 +05:30
case $width in
1) type=byte ;;
2) type=2byte ;;
4) type=4byte ;;
esac
disas() {
2010-06-03 22:48:12 +05:30
${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1
2010-01-05 20:27:58 +05:30
2010-06-03 22:48:12 +05:30
if [ "$ARCH" = "arm" ]; then
if [ $width -eq 2 ]; then
2010-01-05 20:27:58 +05:30
OBJDUMPFLAGS="-M force-thumb"
fi
${CROSS_COMPILE}strip $1.o
fi
${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \
2010-06-03 22:48:12 +05:30
grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1
2010-01-05 20:27:58 +05:30
}
2007-07-15 23:41:15 -07:00
marker=`expr index "$code" "\<"`
if [ $marker -eq 0 ]; then
marker=`expr index "$code" "\("`
fi
2008-12-01 14:21:06 -08:00
touch $T.oo
2007-07-15 23:41:15 -07:00
if [ $marker -ne 0 ]; then
2008-12-01 14:21:06 -08:00
echo All code >> $T.oo
echo ======== >> $T.oo
beforemark=`echo "$code"`
2010-01-05 20:27:58 +05:30
echo -n " .$type 0x" > $T.s
echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s
disas $T
cat $T.dis >> $T.oo
rm -f $T.o $T.s $T.dis
2007-07-15 23:41:15 -07:00
# and fix code at-and-after marker
code=`echo "$code" | cut -c$((${marker} + 1))-`
fi
2008-12-01 14:21:06 -08:00
echo Code starting with the faulting instruction > $T.aa
echo =========================================== >> $T.aa
2010-01-05 20:27:58 +05:30
code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'`
echo -n " .$type 0x" > $T.s
2007-07-15 23:41:15 -07:00
echo $code >> $T.s
2010-01-05 20:27:58 +05:30
disas $T
cat $T.dis >> $T.aa
2008-12-01 14:21:06 -08:00
2010-01-05 20:27:58 +05:30
faultline=`cat $T.dis | head -1 | cut -d":" -f2`
faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'`
2008-12-01 14:21:06 -08:00
cat $T.oo | sed -e "s/\($faultline\)/\*\1 <-- trapping instruction/g"
echo
cat $T.aa
cleanup